Name: ucspi-tcp
Summary: TCP client-server command-line tools
Version: 0.88
Release: 5.art
#Copyright: See djb@pobox.com
License: See djb@pobox.com
Group: Utilities/System
Source: http://cr.yp.to/ucspi-tcp/ucspi-tcp-%{version}.tar.gz
Source1: maketcprules
Source2: ucspi-tcp-docs.tar.gz
Patch0: ucspi-tcp-0.88.errno.patch
Patch1: rblsmtpd-syslog.patch
Patch2: tcpserver-limits-2006-01-26.diff
Patch3: install.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
URL: http://pobox.com/~djb/ucspi-tcp.html
Packager: Scott R. Shinn <scott@atomicrocketturtle.com>
Obsoletes: rblsmtpd

%description
tcpclient and tcpserver are easy-to-use command-line tools for building
TCP client-server applications. tcpclient makes a TCP connection and
runs a program of your choice. tcpserver waits for incoming connections
and, for each connection, runs a program of your choice. Your program
receives environment variables showing the local and remote host names,
IP addresses, and port numbers.

tcpserver offers a concurrency limit to protect you from running out of
processes and memory. When you are handling 40 (by default) simultaneous
connections, tcpserver smoothly defers acceptance of new connections.

tcpserver also provides TCP access control features, similar to
tcp-wrappers/tcpd's hosts.allow but much faster. Its access control
rules are compiled into a hashed format with cdb, so it can easily deal
with thousands of different hosts.

tcpclient and tcpserver conform to UCSPI, the UNIX Client-Server Program
Interface, using the TCP protocol. UCSPI tools are available for several
different networks.


%prep
%setup
tar -xzf %{SOURCE2}

echo /usr >conf-home
echo gcc $RPM_OPT_FLAGS >conf-cc
echo gcc $RPM_OPT_FLAGS -s >conf-ld
cp $RPM_SOURCE_DIR/maketcprules .

%patch0 -p1
%patch1 -p0
%patch2 -p1
%patch3 -p0

%build
make it

%install
rm -fr $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr

echo $RPM_BUILD_ROOT/usr >conf-home
rm -f install.o auto_home.o install
make install
#./install
# The above is just all kinds of screwed up. 
rm -f $RPM_BUILD_ROOT/usr/bin
%{__mkdir_p} %{buildroot}/usr/bin/
%{__mkdir_p} %{buildroot}/etc/tcpcontrol
%{__install} -m 0755 addcr %{buildroot}/usr/bin/addcr
%{__install} -m 0755 argv0 %{buildroot}/usr/bin/argv0
%{__install} -m 0755 date@ %{buildroot}/usr/bin/date@
%{__install} -m 0755 delcr %{buildroot}/usr/bin/delcr
%{__install} -m 0755 finger@ %{buildroot}/usr/bin/finger@
%{__install} -m 0755 fixcrio %{buildroot}/usr/bin/fixcrio
%{__install} -m 0755 http@ %{buildroot}/usr/bin/http@
%{__install} -m 0755 maketcprules %{buildroot}/usr/bin/maketcprules
%{__install} -m 0755 maketcprules %{buildroot}/usr/bin/mconnect
%{__install} -m 0755 mconnect-io %{buildroot}/usr/bin/mconnect-io
%{__install} -m 0755 rblsmtpd %{buildroot}/usr/bin/rblsmtpd
%{__install} -m 0755 recordio %{buildroot}/usr/bin/recordio
%{__install} -m 0755 tcpcat %{buildroot}/usr/bin/tcpcat
%{__install} -m 0755 tcpclient %{buildroot}/usr/bin/tcpclient
%{__install} -m 0755 tcprules %{buildroot}/usr/bin/tcprules
%{__install} -m 0755 tcprulescheck %{buildroot}/usr/bin/tcprulescheck
%{__install} -m 0755 tcpserver %{buildroot}/usr/bin/tcpserver
%{__install} -m 0755 who@ %{buildroot}/usr/bin/who@

%post
/usr/bin/maketcprules

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%config /etc/tcpcontrol
%doc CHANGES README TODO README.tcpserver-limits-patch
%doc ucspi-tcp.html daemontools dnscache docs proto ucspi-tcp
%defattr(0755,root,root)
/usr/bin/*

%changelog
* Fri Mar 13 2009 Scott R. Shinn <scott@atomicrocketturtle.com>
- Cleaned up DJB's build system to not require having to be built as root. 

* Wed Jan 10 2007 Scott R. Shinn <scott@atomicrocketturtle.com>
- added in tcpserver-limits-2006-01-26.diff patch

* Wed Dec 1 2004 Scott R. Shinn <scott@atomicrocketturtle.com>
- added in rblsmtpd-syslog patch

* Mon Mar 20 2000 Bruce Guenter <bruceg@em.ca>
- Updated to version 0.88 of ucspi-tcp.

* Wed Mar 15 2000 Bruce Guenter <bruceg@em.ca>
- Updated to version 0.87 of ucspi-tcp.
- Added "obsoletes" line for rblsmtpd.

* Mon Mar 13 2000 Bruce Guenter <bruceg@em.ca>
- Updated to version 0.86 of ucspi-tcp.
- Added documentation tarball.

* Sun Nov 7 1999 Bruce Guenter <bruceg@em.ca>
- Fixed install race condition exposed on faster computers.

* Sat Nov 14 1998 Bruce Guenter <bruce.guenter@qcc.sk.ca>
- Upgraded package to version 0.84.

* Fri Jul 10 1998 Bruce Guenter <bruce.guenter@qcc.sk.ca>
- Configured the binaries to go into /usr/bin instead of /usr/sbin
- Fixed installation problem with tcpcat (and other shell scripts)

* Tue Jan 20 1998 Bruce Guenter <bruce.guenter@qcc.sk.ca>
- Copied the tcpcconfig program from the old tcpcontrol package,
  renaming it to maketcprules, which works like ldconfig, building all
  the .rules files in /etc/tcpcontrol into .cdb files.
